#ifndef __ANALOG_INPUT_H
#define __ANALOG_INPUT_H

#include <stdbool.h>




// Режим измерения (ток или напряжение)
typedef enum
{
    MEAS_VOLTAGE = 0,
    MEAS_CURRENT,  
    
} MEAS_CHAN_MODE_t;


typedef enum 
{
    MUX_301_CH = 0,
    AN_INP_1,
    AN_INP_2,
    AN_INP_3,
    AN_INP_4,
    AN_INP_5,
    AN_INP_6,
    V_ISO_CL,   // +24 V
    V_ISO,      // +5 V
    
    MUX_401_CH,
    AN_INP_7,
    AN_INP_8,
    AN_INP_9,
    AN_INP_10,
    AN_INP_11,
    AN_INP_12,
    CRNT_LIM_U_BFR_R,
    CRNT_LIM_U_ABFR_R,
    
    NUMBER_ADC_CH,
    
} ANALOG_IN_t;


//
void ai_init(void);

//
void ai_set_meas_mode(void);

//
bool ai_adc_init(void);

//
void ai_processing(void);

//
void adc_get_two_channles(ANALOG_IN_t one, ANALOG_IN_t two);

//
void adc_print_data(void);

// 
void adc_task(void *params);

//
void ai_connect_channel(uint8_t channel);

//
void ai_set_mode(MEAS_CHAN_MODE_t mode, uint8_t channel);

//
void ai_set_mode_word(MEAS_CHAN_MODE_t mode, uint8_t channel);

//
void ai_ext_sens_power(uint16_t state);

//
void ai_leds_processing(void);

//
void ai_connect_test(void);

//
void ai_mode_test(void);



extern uint16_t adc_raw_data[];

extern uint16_t ai_alarm; 

#endif  // __ANALOG_INPUT_H

