#include "at32f403a_407.h"
#include "modbus_ai_params.h"
#include "settings_api.h"
#include "modbus_params.h"
#include "analog_input.h"


extern mb_param_t mb_param[];

#if defined (MAI_12)

//
uint16_t mb_init_ai_params(uint16_t i)
{
    uint16_t index = i;
    uint16_t addr = 0;  
  
    mb_param[index].reg = 0x0300;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&settings.ai_mode_bits;
	mb_param[index].set = mb_set_ai_mode;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    
    mb_param[index].reg = 0x0301;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&ai_alarm;
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    // Сырые данные каналов ADC
    
    mb_param[index].reg = 0x0302;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_1];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
   
    mb_param[index].reg = 0x0303;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_2];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x0304;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_3];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x0305;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_4];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x0306;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_5];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x0307;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_6];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x0308;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_7];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x0309;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_8];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x030A;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_9];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x030B;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_10];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x030C;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_11];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x030D;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[AN_INP_12];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x030E;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[V_ISO_CL];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x030F;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[V_ISO];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x0310;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[CRNT_LIM_U_BFR_R];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x0311;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&adc_raw_data[CRNT_LIM_U_ABFR_R];
	mb_param[index].set = NULL;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    mb_param[index].reg = 0x0320;
	mb_param[index].size = 1;
	mb_param[index].param = (uint8_t*)&settings.ext_sens_power;
	mb_param[index].set = mb_set_ext_sens_power;
    mb_param[index].get = NULL;
    mb_param[index].check_handler = mb_check_dummy;
    
    index++;
    
    return index;
}


// -------------------------------------------------------------------------- //
//                          Установка параметров
// -------------------------------------------------------------------------- //

//
mb_delay_action_t mb_set_ai_mode(void)
{
    ai_set_meas_mode();  
    return MB_SAVE_SETTINGS;
}

//
mb_delay_action_t mb_set_ext_sens_power(void)
{
    ai_ext_sens_power(settings.ext_sens_power);
    
    //sh_ai_connect(0x80);
      
    return MB_SAVE_SETTINGS;
}


#endif